
SC = {};

$.extend(SC, {

	//buttons
	buttonTable : function (buttonArray){
		var buttonTable = $("<table></table>").addClass("buttonTable");
		var buttons = $("<tr></tr>").appendTo(buttonTable);
		for(var i=0;i<buttonArray.length;i++){
			var button = $("<div></div>");
			button.wrap($("<td></td>")).parent().appendTo(buttons);
			button.asComponent("button", buttonArray[i]);
		}
		return buttonTable;
	},//buttonTable

	//ɶԻ
	Dialog : function(dialogPane,doOK){
		this.dialog = $('<div></div>');
		dialogPane.appendTo(this.dialog);
		var button1 = {
			text: "ȷ",
			handler: function() {
				doOK.call();
			}//handler
		};
		var button2 = {
			text: "ȡ",
			handler: function() {
				FR.closeDialog();
			}//handler
		};
		SC.buttonTable([button1,button2]).appendTo(this.dialog);
	},//Dialog
	
	emailAttrDialogPane : function(emailAttr) {
		var emailAttrDialog = $('<div/>');
		var table = $('<table/>');
			table.appendTo($('<div/>')).parent().appendTo(emailAttrDialog);
			var serverName = $('<input id="emailServer"/>');
			serverName.attr('value', emailAttr.serverName);			
			serverName.appendTo($('<td/>')).parent().appendTo($('<tr><td>ʼ</td></tr>')).parent().appendTo(table);
			
			var fromAddress = $('<input id="emailFrom"/>');
			fromAddress.attr('value', emailAttr.fromAddress);	
			fromAddress.appendTo($('<td/>')).parent().appendTo($('<tr><td>ַ</td></tr>')).parent().appendTo(table);
		
			var userName = $('<input id="emailUser"/>');
			userName.attr('value', emailAttr.userName);
			userName.appendTo($('<td/>')).parent().appendTo($('<tr><td>û</td></tr>')).parent().appendTo(table);
					
			var passWord = $('<input id="emailPassword" type="password"/>');
			passWord.attr('value', emailAttr.passWord);
			passWord.appendTo($('<td/>')).parent().appendTo($('<tr><td>룺</td></tr>')).parent().appendTo(table);
			
			var doOK = function() {
				$.ajax({					
					url : '${servletURL}',
					type : 'POST',
					data : {
						type : 'POST',
						op : 'fr_schedule_EmailAttrSet', 
						emailAttrJson : FR.cjkEncode('{"serverName":"' + serverName.val() + '","fromAddress":"' + fromAddress.val() + '","userName":"' + userName.val() + '","passWord":"' + passWord.val() + '"}')
					},
					async : false,
					complete : function(res, status) {
						FR.Msg.alert('Ϣ', eval(res.responseText));
					}
	    		});
				FR.closeDialog();
			};
			return new SC.Dialog(emailAttrDialog, doOK).dialog;
	},
	
	//ļжԻ
	addFolderDialog : function(tree){
		var addFolderPane = $('<div></div>');
		var folderName = $('<p>ļ֣*</p><input id="folderName"/>').appendTo(addFolderPane);
		var folderDesc = $('<p>ļ</p><textarea id="folderDesc" cols="30" rows="3"></textarea>').appendTo(addFolderPane);
		var doOK = function() {
			if(!checkvalid()){
				return;
			}
			var currentItem = tree.getTCT();
			var parentId;
			if (currentItem) {
				parentId = currentItem.id.substr(1);
			} else {
				//b:ĬӵĿ¼
				parentId = -1;
			}

			var name = $("#folderName").attr("value");
			var desc = $("#folderDesc").attr("value");
			var folder = {};
			folder.parentId = parentId;
			folder.text = name;
			folder.hasChildren = true;
			folder.isexpand = true;
			folder.complete = true;
			folder.description = desc;
			$.get(
				"${servletURL}",
				{
				op: "fr_schedule_addFolder",
				type : 'POST',
				folderJason: FR.cjkEncode(JSON.stringify(folder))
				},
				function callback(jason){//غ
					var item = JSON.parse(jason);
					tree.addNode(currentItem,item);
				}//callback
			);
			FR.closeDialog();
		};//doOK
		function checkvalid(){
			if(!$("#folderName").val()){
				$("#folderName").focus();
				alert("ļ");
				return false;
			}
			return true;
		}
		return new SC.Dialog(addFolderPane, doOK).dialog;
	},//addFolderDialog

	//ӱԻ
	addReportDialog : function(tree){
		var addReportPane = $('<div style="overflow:auto"></div>');
		var reportName = $('<p>/ļ֣*</p><input id="reportName"/>').appendTo(addReportPane);
		var reportPath = $('<div><p>/ļ·*</p></div>').appendTo(addReportPane);
		var reportView = $('<p>Ƿ</p><input id="reportWrite" type="checkbox"/>').appendTo(addReportPane);
		var pathTable =$('<table></table>').appendTo(reportPath);
		var pathTR = $('<tr></tr>').appendTo(pathTable);
		//Ŀ¼
		var treePane = $('<div>loading</div>').addClass("tree scrollTree").appendTo(reportPath).hide();//
		var reportTD = $('<input id="reportPath" class="pathInput" readonly="true"/>').wrap($('<td></td>')).parent().appendTo(pathTR);
		var selectButton = $('<div></div>');
		selectButton.wrap($("<td></td>")).parent().appendTo(pathTR);
		selectButton.asComponent("button", {
			text: "ѡ",
			handler: function() {
				if(treePane.html()=='loading'){//WebReportµıĿ¼
					$.get(
						"${servletURL}",
						{	
							type : 'POST',
							op: "fr_schedule_getReport"
						},
						function callback(jasonA){//Ӧ
							var treedata = JSON.parse(jasonA);
							var o = {
								data: treedata,
								onnodeclick: function(){
									var currentItem = treePane.getTCT();
									if(currentItem.hasChildren){
										return;
									}
									$("#reportPath").attr("value", currentItem.path);
									$("#reportName").attr("value", currentItem.text);
								}
							};
							treePane.treeview(o);
						}//callback
					);
				}//if
				treePane.toggle();
			}//handler
		});
		var doOK = function() {
			if(!checkvalid()){
				return;
			}
			var currentItem = tree.getTCT();
			var parentID = currentItem.id.substr(1);//ȥǰ0
			var path = $("#reportPath").attr("value");
			var name = $("#reportName").attr("value");
			var view = !$("#reportWrite").attr("checked");
			$.get(
				"${servletURL}",
				{
					type : 'POST',
					op: "fr_schedule_addReport",
					reportJason: FR.cjkEncode('{"parentId":'+parentID+',"path":"'+path+'","text":"'+name+'","isView":'+view+'}')
				},
				function callback(jason){//غ
					var item = JSON.parse(jason);
					tree.addNode(currentItem,item);
				}//callback
			);
			FR.closeDialog();
		};//doOK
		function checkvalid(){
			if(!$("#reportName").val()){
				$("#reportName").focus();
				alert("뱨");
				return false;
			}
			if(!$("#reportPath").val()){
				$("#reportPath").focus();
				alert("ѡ񱨱·");
				return false;
			}
			return true;
		}
		return new SC.Dialog(addReportPane, doOK).dialog;
	},

	editParameterDialog : function (parameterPane, parameter, parameters, isnew){
		var editPane = editPane();
		editPane.populate(parameter);
		var doOK = function(){
			if(!(editPane.checkvalid())){
				return;
			}
			editPane.update(parameter);
			if(isnew){
				parameters.push(parameter);
			}
			parameterPane.loadParameter(parameters);
			FR.closeDialog();
		}
		
		function editPane(){
			var editPane = $('<div></div>');
			var parametername = $("<p>֣</p><input id='parametername'/>").appendTo(editPane);
			var parametertypecombo = $('<div></div>');
			parametertypecombo.wrap($('<p id="parametertype">ͣ</p>')).parent().appendTo(editPane);
			var parametertypeConfig = {
				editable : false,
				allowBlank : false,
				mode: 'local',
				items: [{value: "String", text: FR.i18n.Parameter_String},
						{value: "Integer", text: FR.i18n.Parameter_Integer},
						{value: "Double", text: FR.i18n.Parameter_Double},
						{value: "Date", text: FR.i18n.Parameter_Date},
						{value: "Boolean", text: FR.i18n.Parameter_Boolean},
						{value: "Formula", text: FR.i18n.Parameter_Formula}]
			};
			var parametertype = parametertypecombo.asComponent("combo", parametertypeConfig);
			var valuePane = valuePane();
			valuePane.wrap($('<p>ֵ</p>')).parent().appendTo(editPane);
			parametertype.on(FR.Events.COLLAPSE, function(){
				if(parametertype.getValue()=="Date"){
					valuePane.setType("Date");
				}else if(parametertype.getValue()=="Boolean"){
					valuePane.setType("Boolean");
				}else{
					valuePane.setType("String");
				}
			});
			
			function valuePane(){
				var valuePane = $('<div></div>');
				var type = "";
				var stringinput = $('<input/>').css("width", "320px").appendTo(valuePane).hide();
				var datediv = $('<div></div>').appendTo(valuePane).hide();
				var timeConfig = {
					width : 150,
					allowBlank : false,
					format : "yyyy-MM-dd"
				};
				var date = datediv.asComponent("datetime", timeConfig);
				var booleancheck = $('<input type="checkbox"/>').appendTo(valuePane).hide();
				valuePane.setValue = function(parametervalue){
					if(type == "Date"){
						date.setValue(parametervalue);
					}else if(type == "Boolean"){
						booleancheck.attr("checked", parametervalue);
					}else{
						stringinput.val(parametervalue);
					}
				}
				valuePane.getValue = function(){
					if(type == "Date"){
						return(date.getValue());
					}else if(type == "Boolean"){
						return booleancheck.attr("checked");
					}else {
						return stringinput.val();
					}
				}
				valuePane.setType = function(parametertype){
					type = parametertype;
					if(type == "Date"){
						datediv.showPane();
					}else if(type == "Boolean"){
						booleancheck.showPane();
					}else {
						stringinput.showPane();
					}
				}
				return valuePane;
			}//valuePane

			editPane.populate = function(parameter){
				editPane.find("#parametername").val(parameter.name);
				parametertype.setValue(parameter.type ? parameter.type : "String");
				valuePane.setType(parameter.type ? parameter.type : "String");
				valuePane.setValue(parameter.value);
			}
			editPane.update = function(parameter){
				parameter.name = $("#parametername").val();
				parameter.type = parametertype.getValue();
				parameter.value = valuePane.getValue();
			}
			editPane.checkvalid = function(){
				if(!$("#parametername").val()){
					$("#parametername").focus();
					alert("");
					return false;
				}
				return true;
			}
			return editPane;
		}//editPane

		return new SC.Dialog(editPane, doOK).dialog;
	}//addParameterDialog

});